# Looper Streaming

## About

Looper was created to make the lives of streamers (or future streamers) easier, who, for some reason, don't have as much time to livestream as they would like. To solve this problem, Looper allows you to create playlists of your recorded content (VOD) and stream them as if they were live on various streaming platforms (for example: YouTube, Twitch, and others).

## Requirements

Looper relies on FFmpeg, a powerful multimedia framework, to handle various tasks such as transcoding, generating thumbnails, streaming, and analyzing your videos. FFmpeg is an essential tool for video processing, enabling Looper to seamlessly manage your content.

While Looper comes with a pre-installed version of FFmpeg for convenience, it may not be compatible with all operating systems. For optimal performance and compatibility, it's recommended to manually install FFmpeg using the provided link below:

- [FFmpeg Official Website](https://ffmpeg.org/download.html)

However, if you prefer to use the pre-installed version provided by Looper, you can easily switch to it through the settings menu. Keep in mind that while this built-in installation is convenient, it may not offer the same level of compatibility and performance as a manual installation, especially on certain operating systems.

## Installation

```bash
npm install -g @pporto/looper-streaming
```

### How will Looper work?

The idea is that you install Looper on your computer or in the cloud (AWS services or Google Cloud), and from there, you can upload your videos, create playlists, and at any moment, start or stop a live broadcast.

## Conguration

1. Open the console on your operating system and type:

```bash
npx looper-streaming
```

2. Open your browser and enter the address http://localhost:8080
3. On the login screen, type "admin" to authenticate (Don't worry, you can change the password in the settings menu)
4. Click on Settings in the menu, in the storage tab, enter the requested information

- Region: Region in AWS where you bucket is located (Ex: us-east-1, us-west-1, af-south-1, etc.)
- Bucket: Name of the bucket
- Aws access key: Access Key created in IAM to allow Looper to access the bucket
- Aws secret key: Secret key created in IAM to allow Looper to access the bucket

5. After you have finished, click on Save and you are ready to use.

### Customize with environment variables

- LOOPER_PORT: Set Looper server port (default: 8080)
- LOOPER_DEBUG: Enable debug logs (default: false)
- LOG_FILE: Save logs in file (default: false)

### Database

The database file is created in homedir()/looper-streaming/database.db

## DONATE

Looper is a free tool that anyone can install and use freely.

- Donate using the [Patreon](https://patreon.com/looperstreaming) platform!
- Donate using the [Apoia-se](https://apoia.se/looper) platform! Best for Brazilian currency (REAL/BRL)
