"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.authRoute = void 0;
const express_1 = require("express");
const yup = __importStar(require("yup"));
const _1 = require(".");
const authentication_service_1 = require("../service/authentication-service");
function authRoute() {
    const route = (0, express_1.Router)();
    route.get('', (req, res, next) => {
        try {
            const authorization = req.headers.authorization;
            res.json(authentication_service_1.authenticationService.authenticate(authorization));
        }
        catch (e) {
            next(e);
        }
    });
    route.put('', _1.requestAuthentication, (0, _1.bodyValidator)({
        body: {
            key: yup.string().required(),
            old: yup.string().required()
        }
    }), (req, res, next) => {
        try {
            const key = req.body.key;
            const old = req.body.old;
            authentication_service_1.authenticationService.setAuthenticationKey(key, old);
            res.sendStatus(204);
        }
        catch (e) {
            next(e);
        }
    });
    return route;
}
exports.authRoute = authRoute;
