"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mediaUploadRoute = void 0;
const express_1 = require("express");
const yup = __importStar(require("yup"));
const media_service_1 = require("../service/media-service");
const _1 = require(".");
function mediaUploadRoute() {
    const route = (0, express_1.Router)();
    route.post("/single", _1.requestAuthentication, (0, _1.bodyValidator)({
        body: {
            fileName: yup.string().required(),
            size: yup.number().required(),
            contentType: yup.string().required(),
        },
    }), (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            res.send(yield media_service_1.mediaService.createMediaWithSingleUpload(req.body));
        }
        catch (e) {
            next(e);
        }
    }));
    route.get(`/multipart`, _1.requestAuthentication, (0, _1.queryValidator)(["uploadId", "key", "index"]), (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            const query = req.query;
            res.send(yield media_service_1.mediaService.getPresignedUploadPartUrl(query.uploadId, query.key, parseInt(query.index)));
        }
        catch (e) {
            next(e);
        }
    }));
    route.post(`/multipart`, _1.requestAuthentication, (0, _1.bodyValidator)({
        body: {
            fileName: yup.string().required(),
            size: yup.number().required(),
            contentType: yup.string().required(),
        },
    }), (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            res.send(yield media_service_1.mediaService.createMediaWithMultipartUpload(req.body));
        }
        catch (e) {
            next(e);
        }
    }));
    route.put(`/complete/:id`, _1.requestAuthentication, (0, _1.bodyValidator)({
        body: {
            objectKey: yup.string().optional(),
            uploadId: yup.string().optional(),
            uploadPartResults: yup
                .array()
                .of(yup.object().shape({
                ETag: yup.string().required(),
                PartNumber: yup.number().required(),
            }))
                .optional(),
        },
    }), (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            yield media_service_1.mediaService.completeMediaUpload(req.params.id, req.body);
            res.sendStatus(204);
        }
        catch (e) {
            next(e);
        }
    }));
    route.put(`/abort/:id`, _1.requestAuthentication, (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            media_service_1.mediaService.abortMediaUpload(req.params.id, req.body);
            res.sendStatus(204);
        }
        catch (e) {
            next(e);
        }
    }));
    return route;
}
exports.mediaUploadRoute = mediaUploadRoute;
