"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.playlistRoute = void 0;
const playlist_model_1 = require("../model/playlist-model");
const yup = __importStar(require("yup"));
const _1 = require(".");
const express_1 = require("express");
const playlist_service_1 = require("../service/playlist-service");
function playlistRoute() {
    const route = (0, express_1.Router)();
    route.get(`/all`, _1.requestAuthentication, (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            res.send(yield playlist_service_1.playlistService.all());
        }
        catch (e) {
            next(e);
        }
    }));
    route.get("", _1.requestAuthentication, (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            const query = req.query;
            res.send(yield playlist_service_1.playlistService.findAllByName((0, _1.getPagination)(req), query.name));
        }
        catch (e) {
            next(e);
        }
    }));
    route.get(`/:id`, _1.requestAuthentication, (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            res.send(yield playlist_service_1.playlistService.findById(req.params.id));
        }
        catch (e) {
            next(e);
        }
    }));
    route.post("", _1.requestAuthentication, (0, _1.bodyValidator)({
        body: {
            name: yup.string().min(3).required(),
            opening_media: yup.string(),
            closing_media: yup.string(),
            break_playlist: yup.string(),
            medias: yup.array(yup.string()).required(),
        },
    }), (req, res, next) => {
        try {
            const id = playlist_model_1.playlistModel.create(req.body);
            res.send(Object.assign(Object.assign({}, req.body), { id }));
        }
        catch (e) {
            next(e);
        }
    });
    route.put(`/:id`, _1.requestAuthentication, (0, _1.bodyValidator)({
        body: {
            name: yup.string().min(3).required(),
            opening_media: yup.string(),
            closing_media: yup.string(),
            break_playlist: yup.string(),
            medias: yup.array(yup.string()).required(),
        },
    }), (req, res, next) => {
        try {
            const update = {
                name: req.body.name,
                opening_media: req.body.opening_media,
                closing_media: req.body.closing_media,
                break_playlist: req.body.break_playlist,
                medias: req.body.medias,
            };
            playlist_model_1.playlistModel.update(update, req.params.id);
            res.send(Object.assign(Object.assign({}, update), { id: req.params.id }));
        }
        catch (e) {
            next(e);
        }
    });
    route.delete(`/:id`, _1.requestAuthentication, (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            playlist_model_1.playlistModel.delete(req.params.id);
            res.sendStatus(204);
        }
        catch (e) {
            next(e);
        }
    }));
    return route;
}
exports.playlistRoute = playlistRoute;
