"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.serverStatusRoute = void 0;
const express_1 = require("express");
const _1 = require(".");
const server_status_service_1 = require("../service/server-status-service");
function serverStatusRoute() {
    const route = (0, express_1.Router)();
    route.get('', _1.requestAuthentication, (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            res.send(server_status_service_1.serverStatusService.getStatus());
        }
        catch (e) {
            next(e);
        }
    }));
    return route;
}
exports.serverStatusRoute = serverStatusRoute;
