"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.streamingRoute = void 0;
const express_1 = require("express");
const yup = __importStar(require("yup"));
const _1 = require(".");
const streaming_service_1 = require("../service/streaming-service");
function streamingRoute() {
    const route = (0, express_1.Router)();
    route.get(`/status`, _1.requestAuthentication, (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            res.send(streaming_service_1.streamingService.getStatus());
        }
        catch (e) {
            next(e);
        }
    }));
    route.get(`/log`, _1.requestAuthentication, (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            res.send({
                log: streaming_service_1.streamingService.getLog(),
            });
        }
        catch (e) {
            next(e);
        }
    }));
    route.put(`/start`, _1.requestAuthentication, (0, _1.bodyValidator)({
        body: {
            playlistId: yup.string().min(1).required(),
            outputId: yup.string().min(1).required(),
            scale: yup.string().min(3).max(4).nullable(),
            loop: yup.boolean().required(),
        },
    }), (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            yield streaming_service_1.streamingService.start(req.body.playlistId, req.body.outputId, req.body.scale, req.body.loop);
            res.send(204);
        }
        catch (e) {
            next(e);
        }
    }));
    route.put(`/stop`, _1.requestAuthentication, (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            streaming_service_1.streamingService.stop();
            res.sendStatus(204);
        }
        catch (e) {
            next(e);
        }
    }));
    return route;
}
exports.streamingRoute = streamingRoute;
