"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.taskRoute = void 0;
const express_1 = require("express");
const yup = __importStar(require("yup"));
const _1 = require(".");
const task_service_1 = require("../service/task-service");
function taskRoute() {
    const route = (0, express_1.Router)();
    route.get(`/log/transcoder`, _1.requestAuthentication, (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            res.send({
                log: task_service_1.mediaTaskService.getTranscoderLog(),
            });
        }
        catch (e) {
            next(e);
        }
    }));
    route.get(`/log/thumbnail`, _1.requestAuthentication, (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            res.send({
                log: task_service_1.mediaTaskService.getThumbnailLog(),
            });
        }
        catch (e) {
            next(e);
        }
    }));
    route.get(`/log/probe`, _1.requestAuthentication, (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            res.send({
                log: task_service_1.mediaTaskService.getProbeLog(),
            });
        }
        catch (e) {
            next(e);
        }
    }));
    route.get("/settings", _1.requestAuthentication, (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            res.send(task_service_1.mediaTaskService.getSettings());
        }
        catch (e) {
            next(e);
        }
    }));
    route.put("/settings", _1.requestAuthentication, (0, _1.bodyValidator)({
        body: {
            probe: yup
                .object()
                .shape({
                timeout: yup.number().min(10000).required(),
                useSystemFFprobe: yup.boolean().required(),
            })
                .required(),
            transcoder: yup
                .object()
                .shape({
                on: yup.boolean().required(),
                useSystemFFmpeg: yup.boolean().required(),
            })
                .required(),
            thumbnail: yup
                .object()
                .shape({
                on: yup.boolean().required(),
                useSystemFFmpeg: yup.boolean().required(),
            })
                .required(),
        },
    }), (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            task_service_1.mediaTaskService.setSettings(req.body);
            res.sendStatus(204);
        }
        catch (e) {
            next(e);
        }
    }));
    route.get(`/transcoder`, _1.requestAuthentication, (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            res.send(task_service_1.mediaTaskService.getTranscoderSettings());
        }
        catch (e) {
            next(e);
        }
    }));
    route.put(`/transcoder`, _1.requestAuthentication, (0, _1.bodyValidator)({
        body: {
            crf: yup.number().min(0).max(51).required(),
            fps: yup.number().min(1).max(120).required(),
            bufsize: yup.number().min(1).required(),
            max_rate: yup.number().min(1).required(),
            audio_bitrate: yup.number().min(1).required(),
            scale: yup.string().required(),
            audio_sample_rate: yup.number().min(1).required(),
        },
    }), (req, res, next) => __awaiter(this, void 0, void 0, function* () {
        try {
            task_service_1.mediaTaskService.setTranscoderSettings({
                crf: req.body.crf,
                fps: req.body.fps,
                bufsize: req.body.bufsize,
                max_rate: req.body.max_rate,
                audio_bitrate: req.body.audio_bitrate,
                scale: req.body.scale,
                audio_sample_rate: req.body.audio_sample_rate,
            });
            res.sendStatus(204);
        }
        catch (e) {
            next(e);
        }
    }));
    return route;
}
exports.taskRoute = taskRoute;
