#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const app_1 = __importDefault(require("./app"));
const constants_1 = require("./util/constants");
const CUSTOM_ARGS = {
    DROP_DATABASE: "--drop-database"
};
const args = process.argv.slice(2);
console.log(args);
if (args.includes(CUSTOM_ARGS.DROP_DATABASE)) {
    if (fs_1.default.existsSync(constants_1.DATABASE.DB_FILE_NAME)) {
        console.log('Found db file, starting delete process.');
        fs_1.default.unlinkSync(constants_1.DATABASE.DB_FILE_NAME);
        console.log('db file deleted! process completed.');
    }
    else {
        console.log('Db file not found.');
    }
}
else {
    app_1.default.start();
}
