"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.playlistModel = exports.PlaylistModel = void 0;
const base_model_1 = require("./base-model");
const sqlite_client_1 = require("./sqlite-client");
class PlaylistModel extends base_model_1.BaseModel {
    constructor(sqlite = sqlite_client_1.sqliteClient) {
        super(`playlist`, sqlite);
    }
    create(data) {
        return super.create(Object.assign(Object.assign({}, data), { medias: JSON.stringify(data.medias) }));
    }
    update(data, id) {
        super.update(Object.assign(Object.assign({}, data), { medias: JSON.stringify(data.medias) }), id);
    }
    findById(id) {
        const record = super.findById(id);
        if (record)
            return this.parseMediaListStringToArray(record);
    }
    findAll() {
        const data = this.list();
        return this.parseListOfMediaListStringToArray(data);
    }
    findByLike(pagination, str) {
        const data = super.findByLike(pagination, str);
        return Object.assign(Object.assign({}, data), { records: this.parseListOfMediaListStringToArray(data.records) });
    }
    parseListOfMediaListStringToArray(rows) {
        return rows.map((row) => this.parseMediaListStringToArray(row));
    }
    parseMediaListStringToArray(row) {
        const mediaList = row.medias ? JSON.parse(row.medias) : [];
        return Object.assign(Object.assign({}, row), { medias: mediaList });
    }
}
exports.PlaylistModel = PlaylistModel;
exports.playlistModel = new PlaylistModel();
