"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConsoleModule = void 0;
const log_history_util_1 = require("../util/log-history-util");
const logger_1 = __importDefault(require("../util/logger"));
class ConsoleModule {
    constructor() {
        this.console = new log_history_util_1.LogHistoryUtil();
    }
    getLog() {
        return this.console.getLog();
    }
    clear() {
        this.console.clear();
    }
    info(message) {
        this.log('INFO', message);
        logger_1.default.info(message);
    }
    warn(message) {
        this.log('WARN', message);
        logger_1.default.warn(message);
    }
    error(message) {
        this.log('ERROR', message);
        logger_1.default.error(message);
    }
    debug(message) {
        if (process.env.LOOPER_DEBUG)
            this.log('DEBUG', message);
        logger_1.default.debug(message);
    }
    log(level, message) {
        let print = message;
        if (message instanceof Object) {
            print = JSON.stringify(print);
        }
        this.console.append(`${level}: ${print}`);
    }
}
exports.ConsoleModule = ConsoleModule;
