"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ffprobeModule = exports.FfprobeModule = void 0;
const os_1 = __importDefault(require("os"));
const fs_1 = __importDefault(require("fs"));
const child_process_1 = require("child_process");
const ffprobe_1 = require("@ffprobe-installer/ffprobe");
const OUTPUT_PATH = `${os_1.default.tmpdir()}/probe.json`;
class FfprobeModule {
    getCommand(url, useSystemFFprobe) {
        const probePath = useSystemFFprobe ? 'ffprobe' : ffprobe_1.path;
        return `${probePath} "${url}" -hide_banner -v quiet -of json -show_streams -show_format > ${OUTPUT_PATH}`.replace("\n", "");
    }
    onAnalysesEnd(err, stdout, stderr, callback) {
        if (err || stderr) {
            callback(err, stderr);
        }
        else {
            const rawFile = fs_1.default.readFileSync(OUTPUT_PATH);
            callback(undefined, JSON.parse(rawFile));
        }
    }
    analysis(url, callback, timeout, useSystemFFprobe = false) {
        (0, child_process_1.exec)(this.getCommand(url, useSystemFFprobe), { timeout }, (err, stdout, stderr) => this.onAnalysesEnd(err, stdout, stderr, callback));
    }
}
exports.FfprobeModule = FfprobeModule;
exports.ffprobeModule = new FfprobeModule();
