"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.authenticationService = exports.AuthenticationService = exports.authenticationToken = void 0;
const constants_1 = require("../util/constants");
const util_1 = require("../util");
const config_model_1 = require("../model/config-model");
class AuthenticationTokenUtil {
    refresh() {
        this.token = util_1.uuid.generate();
    }
    verify(token) {
        return this.token === token;
    }
    getToken() {
        return {
            token: this.token
        };
    }
}
exports.authenticationToken = new AuthenticationTokenUtil();
class AuthenticationService {
    constructor(configM = config_model_1.configModel) {
        this.configModel = configM;
    }
    authenticate(key) {
        if (!key) {
            throw constants_1.ERROR.FORBIDDEN;
        }
        this.isValidAuthenticationKey(key);
        exports.authenticationToken.refresh();
        return exports.authenticationToken.getToken();
    }
    setAuthenticationKey(key, old) {
        this.isValidAuthenticationKey(old);
        this.configModel.setSecretKey(key);
    }
    isValidAuthenticationKey(key) {
        if (this.configModel.getSecretKey() !== key) {
            throw constants_1.ERROR.FORBIDDEN;
        }
    }
}
exports.AuthenticationService = AuthenticationService;
exports.authenticationService = new AuthenticationService();
