"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.storageService = exports.StorageService = void 0;
const config_model_1 = require("../model/config-model");
class StorageService {
    constructor(configM = config_model_1.configModel) {
        this.configModel = configM;
    }
    getStorageSettings() {
        var _a, _b;
        const row = this.configModel.getStorageSettings();
        if (row.provider == config_model_1.StorageProviderEnum.AWS) {
            return {
                provider: row.provider,
                aws: {
                    region: (_a = row.aws) === null || _a === void 0 ? void 0 : _a.region,
                    bucket: (_b = row.aws) === null || _b === void 0 ? void 0 : _b.bucket
                },
                isConfigured: row.isConfigured
            };
        }
    }
    setStorageSettings(settings) {
        settings.isConfigured = true;
        config_model_1.configModel.setStorageSettings(settings);
    }
}
exports.StorageService = StorageService;
exports.storageService = new StorageService();
