"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mediaTaskService = exports.MediaTaskService = void 0;
const config_model_1 = require("../model/config-model");
const media_task_manager_1 = require("../tasks/media-task-manager");
class MediaTaskService {
    constructor(configM = config_model_1.configModel, mediaTaskM = media_task_manager_1.mediaTaskManager) {
        this.configModel = configM;
        this.mediaTaskManager = mediaTaskM;
    }
    getThumbnailLog() {
        return this.mediaTaskManager.getThumbnailLog();
    }
    getTranscoderLog() {
        return this.mediaTaskManager.getTranscoderLog();
    }
    getProbeLog() {
        return this.mediaTaskManager.getFfprobeLog();
    }
    getSettings() {
        return this.configModel.getTasksSettings();
    }
    setSettings(settings) {
        this.configModel.setTasksSettings(settings);
        this.mediaTaskManager.setSettings(settings);
    }
    getTranscoderSettings() {
        return this.configModel.getTranscoderSettings();
    }
    setTranscoderSettings(settings) {
        config_model_1.configModel.setTranscoderSettings(settings);
    }
    start() {
        const settings = this.getSettings();
        media_task_manager_1.mediaTaskManager.setSettings(settings);
        media_task_manager_1.mediaTaskManager.start();
    }
}
exports.MediaTaskService = MediaTaskService;
exports.mediaTaskService = new MediaTaskService();
