"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const media_model_1 = require("../model/media-model");
const server_status_task_1 = require("./server-status-task");
jest.mock('../model/media-model');
const mediaModelMock = media_model_1.mediaModel;
const service = new server_status_task_1.ServerStatusTask(mediaModelMock);
describe('server-status-task', () => {
    const mediaStatus = {
        size: 1000,
        duration: 1000,
        count_medias: 1,
        total_analysis_fail: 1,
        total_ready: 1,
        total_under_analysis: 1,
        total_upload: 1,
        total_upload_failed: 1
    };
    beforeEach(() => {
        mediaModelMock.getTotalDurationAndSize.mockReturnValue(mediaStatus);
    });
    describe('getStatus', () => {
        test('should get machine status', () => __awaiter(void 0, void 0, void 0, function* () {
            yield service.requestDiskUsage();
            yield service.requestMachineStatus();
            const status = service.getStatus();
            expect(status.media).toEqual(mediaStatus);
            expect(status.cpu).not.toEqual(0);
            expect(status.disk).not.toEqual(0);
            expect(status.mem).not.toEqual(0);
        }));
    });
});
