"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const sqlite_client_1 = require("../model/sqlite-client");
const sync_with_backup_task_1 = require("./sync-with-backup-task");
const constants_1 = require("../util/constants");
const DB_FILE = 'test/syncWithBackup.db';
const BACKUP_DB_FILE = 'test/backupExample.db';
const sqliteClient = new sqlite_client_1.SqliteClient(DB_FILE);
const task = new sync_with_backup_task_1.SyncWithBackupTask(sqliteClient);
describe('SyncWithBackupTask', () => {
    beforeAll(() => {
        fs_1.default.copyFileSync(BACKUP_DB_FILE, constants_1.DEFAULT_DOWNLOADED_BACKUP_DB);
    });
    afterAll(() => {
        if (fs_1.default.existsSync(DB_FILE))
            fs_1.default.unlinkSync(DB_FILE);
        if (fs_1.default.existsSync(constants_1.DEFAULT_DOWNLOADED_BACKUP_DB))
            fs_1.default.unlinkSync(constants_1.DEFAULT_DOWNLOADED_BACKUP_DB);
    });
    test('should insert data from a backup', () => {
        const data = task.run();
        expect(data).toEqual({
            amountMedias: 10,
            amountOutputs: 10,
            amountPlaylists: 10
        });
    });
});
