"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogHistoryUtil = void 0;
const logger_1 = __importDefault(require("./logger"));
class LogHistoryUtil {
    constructor(maxLength = 80000) {
        this.output = "";
        this.maxLength = maxLength;
    }
    append(text) {
        logger_1.default.debug(text);
        this.output = `${text}\n${this.output}`;
        if (this.output.length > this.maxLength)
            this.output = this.output.slice(this.maxLength - (this.maxLength % 10));
    }
    clear() {
        this.output = "";
    }
    getLog() {
        return this.output;
    }
}
exports.LogHistoryUtil = LogHistoryUtil;
