const { spawn } = require('child_process')
const ffmpegPath = require('@ffmpeg-installer/ffmpeg').path

const paramsList = JSON.parse(process.argv[2])
const useSystemFfmpeg = process.argv[3]
const sendLog = process.argv[4]

/*
// transcode
const paramsList = [
  "-y", "-hide_banner",
  "-v", "error",
  "-probesize", "10M",
  "-analyzeduration", "10M",
  "-i", "test/teste.mp4",
  "-preset", "fast",
  "-profile:v", "high",
  "-c:v", "libx264",
  "-c:a", "aac",
  "-crf", 30,
  //"-b:v", config.video_bitrate,
  "-b:a", 128000,
  "-ar", 44100,
  "-pix_fmt", "yuv420p",
  "-maxrate", 1500000,
  "-bufsize", 2250000,
  "-force_key_frames", "expr:gte(t,n_forced*4)",
  //            "-g", "58",
  //            "-keyint_min", "58", 
  "-bf", "3",
  "-b_strategy", "2",
  "-sc_threshold", "0",
  "-refs", "10",
  "-vf", `fps=${24},scale=iw*sar:ih,scale=${'240'}:trunc(ow/a/2)*2`,
  "-strict", "-2",
  "-f", "mp4",
  "test/output.mp4"
]
*/
/*
 * example of the expected transmission
const paramsList = [
  "-y",
  "-hide_banner",
  "-v",
  "warning",
  "-re",
  "-safe",
  "0",
  "-protocol_whitelist",
  "file,http,https,tcp,tls,crypto",
  "-f",
  "concat",
  "-i",
  "C:\\Users\\cesar\\AppData\\Local\\Temp/playlistFile",
  "-c",
  "copy",
  "-tune",
  "zerolatency",
  "-preset",
  "veryfast",
  "-f",
  "flv",
  "rtmp://localhost:1935/stream/looper",
]
*/

let killed = false
const forceExitWords = [
  'non-monotonous'
]

const ffmpeg = useSystemFfmpeg ? "ffmpeg" : ffmpegPath

const worker = spawn(ffmpeg, paramsList)
worker.on('close', (code) => {
  if (code !== 0) {
    const status = killed ? 1 : code
    process.exit(status)
  }
})

worker.stdout.setEncoding('utf8')
worker.stdout.on('data', (data) => {
  console.log(data)
  if (sendLog) {
    process.send(data)
  }

  for (exitWord in forceExitWords) {
    if (data.toLowerCase().includes(exitWord)) {
      killed = true
      worker.kill()
      break
    }
  }
})
worker.stderr.setEncoding('utf8')
worker.stderr.on('data', (data) => {
  console.log(data)
  if (sendLog) {
    process.send(data)
  }

  for (exitWord in forceExitWords) {
    if (data.toLowerCase().includes(exitWord)) {
      killed = true
      worker.kill()
      break
    }
  }
})